program Bildschirmschoner;  //Als Digitale Uhr
//Exeprogramm umtaufen in ".scr" und im Windows-Systemverzeichnis abspeichern

uses
  extctrls, //fr timer
  graphics, //fr clblack
  controls, //fr alNone
  SysUtils, //Fr beep
  Windows, //THandle
  Classes,  //Fr TComponent
  Forms,    // Fr TForm
  Dialogs,  //fr showmessage
  Messages, //fr wm_sysCommand
  StdCtrls; //Fr TButton
type
  TAForm = class(TForm)
  labelDigitaleUhr: TLabel;
  timer1: TTimer;
  procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
  procedure TimerdigitaleUhr(Sender: TObject);
  private
    zaehl: integer; //Verzgert bei Mousemove close
  public
    Constructor Create(aOwner: TComponent); override;
    Destructor Destroy; override;
  end;

Constructor TAForm.Create;
  const clblau = TColor($00CF9030);
begin
    inherited CreateNew(aOwner);
    zaehl := 0;
    with self do Begin
      Formstyle   := fsStayOnTop;
      Bordericons := []; //
      Borderstyle := bsnone;
      WindowState := wsnormal;
      align       := alnone;
      Top         :=0;
      left        :=0;
      Width       := screen.Width;
      height      := screen.height;
      Color       := clBlack;
      cursor      := -1;    //Kein Cursor!
      onkeydown   := FormKeyDown;
      onmousemove := FormMousemove;
   End;
   labelDigitaleUhr := TLabel.Create(self);
   with labelDigitaleUhr do Begin
     Parent := self;
     top := 0;
     left := 0;
     font.Height := 40;
     font.Style := [fsbold];
     font.Name := 'Times Roman';
     color := clblau;
   End;
   timer1 := TTimer.Create(self);
   with timer1 do Begin
     interval := 1000*60; //Jede Minute
     ontimer := TimerdigitaleUhr;
   End;
   TimerdigitaleUhr(nil);
end;

Destructor TAForm.Destroy;
begin
  inherited Destroy;
end;

procedure TAForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState); //Reagiert auch auf Nicht ASCII-Zeichen
begin
  close; //Hauptfenster close heit: Programm beenden
end;

procedure TAForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer); //Wird das erste Mal schon beim Starten aufgerufen
begin
  inc(zaehl);
  if zaehl > 5 then close;
end;

procedure TAForm.TimerdigitaleUhr(Sender: TObject);

begin
  labelDigitaleUhr.Caption := FormatDateTime('dddd," "d.mm.yyyy    hh:nn"', Now);
  labelDigitaleUhr.left := (self.width - labelDigitaleUhr.width) div 2;
  if labelDigitaleUhr.top > self.Height - 100 then labelDigitaleUhr.top := 0 else
    labelDigitaleUhr.top := labelDigitaleUhr.top + 1;
end;

procedure ZweimalVerhindern;
var h: HWND;
begin
  h:=FindWindow('TAForm','Bildschirmschoner (c) Joachim Mohr');
  if h<>0 then Begin SetForegroundWindow(h); halt End;
end;

//---------- Hauptprogramm ---------------
  var DigitaleUhr:TAForm;
begin
  ZweimalVerhindern;
  DigitaleUhr := TAForm.create(Nil);
  DigitaleUhr.Caption :='Bildschirmschoner (c) Joachim Mohr';
  DigitaleUhr.showmodal;
end.

